// Copyright © 2009-2011 Kris Maglione <maglione.k@gmail.com>
//
// This work is licensed for reuse under an MIT license. Details are
// given in the LICENSE file included with this file.

let EXPORTED_SYMBOLS = ["xmlToDom"];

function xmlToDom(node, document, nodes) {
    if (node.length() != 1) {
        let domnode = document.createDocumentFragment();
        for each (let child in node)
            domnode.appendChild(xmlToDom(child, document, nodes));
        return domnode;
    }

    switch (node.nodeKind()) {
    case "text":
        return document.createTextNode(String(node));
    case "element":
        let domnode = document.createElementNS(node.namespace(), node.localName());
        for each (let attr in node.@*::*)
            domnode.setAttributeNS(attr.namespace(), attr.localName(), String(attr));

        for each (let child in node.*::*)
            domnode.appendChild(xmlToDom(child, document, nodes));
        if (nodes && node.@key)
            nodes[node.@key] = domnode;
        return domnode;
    default:
        return null;
    }
};
